#include <amxmodx>
#include <aes_v>
#include <fakemeta>
#include <reapi>

#define MYSQL_SUPPORT	// Раскомментируйте данный define, если хотите сохранять в БД MYSQL(по умолчанию, сохранение через nvault)

#if defined MYSQL_SUPPORT
#include <sqlx>
#else
#include <nvault>
#endif

enum _:Cvars
{
	Float:ENT_LIFETIME,
	GLOW,
	AES_DEAD,
	AES_ALL,
	AES_EXP,
	TIME_DELETE,
	AES_BONUS
}

new g_eCvar[Cvars];

enum _:PlayerData
{
	KEY_ID,
	COIN
};

new g_ePlayerData[MAX_PLAYERS + 1][PlayerData];

new const ENT_CLASSNAME[] = "raise_the_coin";
new const ENT_MODEL[] = "models/exp.mdl";
//new const SND_PICKUP[] = "exp.wav";

// НАСТРОЙКА ДАННЫХ MYSQL (Вводить, если раскомментировон #define MYSQL_SUPPORT)
#if defined MYSQL_SUPPORT
new const Host[]	= "";		// ip адрес хоста
new const User[]	= "";			// Имя хоста
new const Pass[]	= "";			// Пароль хоста
new const Db[]		= "";	// Название бд
// КОНЕЦ НАСТРОЙКИ ДАННЫХ MYSQL

new Handle:g_hSQLTuple;
new bool:g_bLoginPlayer[MAX_PLAYERS + 1], bool:g_FailedSuccesDB;
#else
new g_Vault;
#endif

public plugin_precache()
{
	precache_model(ENT_MODEL);
	//precache_sound(SND_PICKUP);
}

public plugin_init()
{
	register_plugin("(AES)Raise_the_coin", "1.0.0", "Baton4ik48 & Albertio");

	RegisterHookChain(RG_CBasePlayer_Killed, "CBasePlayer_Killed_Post", .post = true);

	bind_pcvar_float(create_cvar("raise_ent_life", "7.0", FCVAR_NONE), g_eCvar[ENT_LIFETIME]); // Время через которое исчезнет монета
	bind_pcvar_num(create_cvar("raise_ent_glow", "0", FCVAR_NONE), g_eCvar[GLOW]); // Свечение монеты
	bind_pcvar_num(create_cvar("raise_dead_exp", "1", FCVAR_NONE), g_eCvar[AES_DEAD]); // Кол-во опыта теряемое при смерти (ставить без минуса)
	bind_pcvar_num(create_cvar("raise_aes_all", "30", FCVAR_NONE), g_eCvar[AES_ALL]); // Необходимое кол-во монет до вознаграждения
	bind_pcvar_num(create_cvar("raise_aes_exp", "10", FCVAR_NONE), g_eCvar[AES_EXP]); // Кол-во опыта за вознаграждении
	bind_pcvar_num(create_cvar("raise_aes_bonus", "10", FCVAR_NONE), g_eCvar[AES_BONUS]); // Кол-во бонусов за вознаграждении
	bind_pcvar_num(create_cvar("raise_deletetime", "30", FCVAR_NONE), g_eCvar[TIME_DELETE]); // Записи игроков, не заходивших указанное кол-во дней, удаляются из хранилища. Меньше 1, - отключить (не рекомендуется) Квар для nvault!!!

	set_task(2.0, "Task_HudMsg", .flags = "b");
}

public plugin_cfg()
{
#if defined MYSQL_SUPPORT
	SQL_SetAffinity("mysql");
	g_hSQLTuple = SQL_MakeDbTuple(Host, User, Pass, Db);

	SQL_SetCharset(g_hSQLTuple, "utf8");

	new szQuery[MAX_FMT_LENGTH];
	
	formatex(szQuery, charsmax(szQuery),
	"CREATE TABLE IF NOT EXISTS `Raise_the_coin` (\
	`id` int(11) NOT NULL AUTO_INCREMENT,\
	`steamid` varchar(64) NOT NULL UNIQUE,\
	`coin` int(11) DEFAULT 0,\
	PRIMARY KEY (`id`)\
	)ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;");

	SQL_ThreadQuery(g_hSQLTuple, "func_QueryHandler", szQuery);
#else
	g_Vault = nvault_open("raise_the_coin");
	if(g_Vault == INVALID_HANDLE)
	{
		set_fail_state("Error nvault");
	}
	if(g_eCvar[TIME_DELETE] > 0)
	{
		nvault_prune(g_Vault, 0, get_systime() - (86400 * g_eCvar[TIME_DELETE]));
	}
#endif
}

public CBasePlayer_Killed_Post(pVictim, pAttacker, pGib)
{
	new Float:vecOrigin[3], Float:vecVelocity[3];

	get_entvar(pVictim, var_origin, vecOrigin);

	new iEntity = rg_create_entity("info_target", false);

	if(is_nullent(iEntity))
	{
		return;
	}

	aes_add_player_exp_f(pVictim, -g_eCvar[AES_DEAD]);

	vecVelocity[0] = random_float(-200.0, 200.0);
	vecVelocity[1] = random_float(-200.0, 200.0);
	vecVelocity[2] = random_float(1.0, 200.0);

	engfunc(EngFunc_SetModel, iEntity, ENT_MODEL);
	engfunc(EngFunc_SetSize, iEntity, {-9.0, -7.0, -0.0}, {9.0, 7.0, 6.0});
	set_entvar(iEntity, var_framerate, 1.0);
	set_entvar(iEntity, var_sequence, 2);
	engfunc(EngFunc_AnimationAutomove, iEntity, 100.0);

	set_entvar(iEntity, var_origin, vecOrigin);
	set_entvar(iEntity, var_classname, ENT_CLASSNAME);
	set_entvar(iEntity, var_movetype, MOVETYPE_TOSS);
	set_entvar(iEntity, var_solid, SOLID_TRIGGER);
	set_entvar(iEntity, var_velocity, vecVelocity);
	set_entvar(iEntity, var_nextthink, get_gametime() + g_eCvar[ENT_LIFETIME]);

	if(g_eCvar[GLOW])
	{
		set_entvar(iEntity, var_rendermode, kRenderGlow);
		set_entvar(iEntity, var_renderamt, 1.0);
		set_entvar(iEntity, var_rendercolor, Float:{0.0, 255.0, 0.0});
		set_entvar(iEntity, var_renderfx, kRenderFxGlowShell);
	}

	SetThink(iEntity, "Cashbrick_Think");
	SetTouch(iEntity, "Cashbrick_Touch");
}

public Cashbrick_Think(pEntity)
{
	if(!is_entity(pEntity))
	{
		return;
	}

	if(get_entvar(pEntity, var_iuser2))
	{
		new Float:fRenderAmt;
		get_entvar(pEntity, var_renderamt, fRenderAmt);

		if(fRenderAmt > 20.0)
		{
			set_entvar(pEntity, var_renderamt, fRenderAmt - 20.0);
			set_entvar(pEntity, var_nextthink, get_gametime() + 0.1);
		}
		else
		{
			set_entvar(pEntity, var_flags, FL_KILLME);
		}
	}
	else
	{
		set_entvar(pEntity, var_iuser2, 1);
		set_entvar(pEntity, var_rendermode, kRenderTransTexture);
		set_entvar(pEntity, var_renderamt, 255.0);
		set_entvar(pEntity, var_nextthink, get_gametime() + 1.5);
	}
}

public Cashbrick_Touch(pEntity, pToucher)
{
	if(!is_entity(pEntity) || !is_user_connected(pToucher))
	{
		return;
	}

	g_ePlayerData[pToucher][COIN]++;
	set_hudmessage(0, 255, 0, -1.0, 0.26, 0, 0.1, 2.0, 0.1, 0.1, 3);
	show_hudmessage(pToucher, "+1 монета");
	//rh_emit_sound2(pToucher, 0, CHAN_ITEM, SND_PICKUP, VOL_NORM, ATTN_NORM);
	set_entvar(pEntity, var_flags, FL_KILLME);

	if(g_ePlayerData[pToucher][COIN] == g_eCvar[AES_ALL])
	{
		client_print_color(pToucher, print_team_default, "^1Вы получили ^4%i ^1опыта и ^4%i ^1бонус.", g_eCvar[AES_EXP], g_eCvar[AES_BONUS]);
		aes_add_player_exp_f(pToucher, g_eCvar[AES_EXP]);
		aes_add_player_bonus_f(pToucher, g_eCvar[AES_BONUS]);
		g_ePlayerData[pToucher][COIN] = 0;
	}
}

public Task_HudMsg()
{
	set_hudmessage(200, 200, 200, 0.01, 0.90, 0, 0.1, 1.0, 0.1, 0.1, 4);

	for(new id = 1; id < MaxClients; id++)
	{
		if(!is_user_alive(id))
		{
			continue;
		}

		show_hudmessage(id, "Монет до вознаграждения: %i/%i", g_ePlayerData[id][COIN], g_eCvar[AES_ALL]);
	}
}

public client_putinserver(id)
{
	if(!is_user_bot(id) || !is_user_hltv(id))
	{
		return;
	}
#if defined MYSQL_SUPPORT
	func_GetPlayerData(id);
	if(!g_FailedSuccesDB && !g_bLoginPlayer[id])
	{
		func_CreateSave(id);
	}
#else
	load_coins(id);
#endif
}

public client_disconnected(id)
{
	if(!is_user_bot(id) || !is_user_hltv(id))
	{
		return;
	}
#if defined MYSQL_SUPPORT
	func_SavePlayerData(id);
	func_ClearDataPlayer(id);
#else
	save_coins(id);
#endif
}

public plugin_end()
{
#if defined MYSQL_SUPPORT
	SQL_FreeHandle(g_hSQLTuple);
#else
	nvault_close(g_Vault);
#endif
}

#if defined MYSQL_SUPPORT
public func_QueryHandler(iFailState, Handle:Query, szError[], iErrNum, data[], size, Float:flQueryTime) 
{
	if(iFailState != TQUERY_SUCCESS)
	{
		log_amx("MySQL Error: %d (%s)", iErrNum, szError);
		g_FailedSuccesDB = true;
		return;
	}
	else
	{
		g_FailedSuccesDB = false;
		return;		
	}
}

public func_GetPlayerData_QueryHandler(iFailState, Handle:Query, szError[], iErrNum, data[], size, Float:flQueryTime) 
{
	if(g_FailedSuccesDB)
	{
		return;
	}

	if(iFailState != TQUERY_SUCCESS)
	{
		log_amx("MySQL Error: %d (%s)", iErrNum, szError);
		return;
	}
	
	new id = data[0];
	
	if(SQL_NumResults(Query) > 0)
	{
		g_ePlayerData[id][KEY_ID] = SQL_ReadResult(Query, SQL_FieldNameToNum(Query, "id"));
		g_ePlayerData[id][COIN] = SQL_ReadResult(Query, SQL_FieldNameToNum(Query, "coin"));
		
		g_bLoginPlayer[id] = true;
	}
}

public func_Create_QueryHandler(iFailState, Handle:Query, szError[], iErrNum, data[], size, Float:flQueryTime) 
{
	if(g_FailedSuccesDB)
	{
		return;
	}

	if(iFailState != TQUERY_SUCCESS)
	{
		log_amx("MySQL Error: %d (%s)", iErrNum, szError);
		return;
	}
	
	new id = data[0];
	
	func_GetPlayerData(id);
	
	g_bLoginPlayer[id] = true;
}

func_GetPlayerData(id)
{
	if(g_FailedSuccesDB)
	{
		return;
	}

	new szQuery[MAX_FMT_LENGTH], szAuthID[MAX_AUTHID_LENGTH], iData[2];
	
	get_user_authid(id, szAuthID, charsmax(szAuthID));
	
	iData[0] = id;
	
	formatex(szQuery, charsmax(szQuery), "SELECT * FROM `Raise_the_coin` WHERE `steamid` = '%s'", szAuthID);
	SQL_ThreadQuery(g_hSQLTuple, "func_GetPlayerData_QueryHandler", szQuery, iData, charsmax(iData));
}

func_SavePlayerData(id)
{
	if(g_FailedSuccesDB)
	{
		return;
	}

	new szQuery[MAX_FMT_LENGTH], iData[2];
	
	iData[0] = id;
	
	formatex(szQuery, charsmax(szQuery),
	"UPDATE `Raise_the_coin` SET `coin` = '%d' WHERE `id` = '%d'",
	g_ePlayerData[id][COIN], g_ePlayerData[id][KEY_ID]);
	SQL_ThreadQuery(g_hSQLTuple, "func_QueryHandler", szQuery, iData, charsmax(iData));
}

func_ClearDataPlayer(id)
{
	g_bLoginPlayer[id] = false;

	g_ePlayerData[id][KEY_ID] = 0;
	g_ePlayerData[id][COIN] = 0;
}

func_CreateSave(id)
{
	if(g_FailedSuccesDB)
	{
		return;
	}

	new szQuery[MAX_FMT_LENGTH], szAuthID[MAX_AUTHID_LENGTH], iData[2];
	
	get_user_authid(id, szAuthID, charsmax(szAuthID));
	
	iData[0] = id;
	
	formatex(szQuery, charsmax(szQuery), "INSERT INTO `Raise_the_coin` (steamid) VALUES ('%s')", szAuthID);
	SQL_ThreadQuery(g_hSQLTuple, "func_Create_QueryHandler", szQuery, iData, charsmax(iData));
}
#else
save_coins(id)
{
	new szAuthID[MAX_AUTHID_LENGTH], szCoin[15];

	get_user_authid(id, szAuthID, charsmax(szAuthID));

	formatex(szCoin, charsmax(szCoin), "%i", g_ePlayerData[id][COIN]);
	nvault_set(g_Vault, szAuthID, szCoin);
}

load_coins(id)
{
	new szAuthID[MAX_AUTHID_LENGTH], szCoin[15];

	get_user_authid(id, szAuthID, charsmax(szAuthID));

	nvault_get(g_Vault, szAuthID, szCoin, charsmax(szCoin));
	g_ePlayerData[id][COIN] = str_to_num(szCoin);
}
#endif